Subject: Re: [Fwd: FVWM-2.3.6 patch submissions]

From: Dominik Vogt <[email-masked]>
Date: Wed, 1 Sep 1999 02:28:10 +0200

On Tue, Aug 31, 1999 at 11:24:55PM +0100, Mark Rainford wrote:
> 8/26/99 12:12 Dominik Vogt wrote:
> 
>             Mark, 
>             that patch works only as one would expect if the styles 
>             RaiseTransient and LowerTransient are used. I could imagine 
>             the final behaviour like this: 
>             There are three styles, (Dont)RaiseTransient and 
>             (Dont)LowerTransient plus (Dont)StackTransientParent. 
>             The first should work as the man page says: If they are 
>             set, raising/lowering the parent window raises/lowers 
>             transients too. The StackTransientParent style additionally 
>             says that the parent window is to be raised/lowered together 
>             with its transients whenever a transient is raised/lowered. 
> 
> Sounds okay. But is it only the raised transient and its parent which
> move, or does the movement of the parent raise all its transients too?
> (as if the Raise action was acting on the parent). The patch does
> the second.

I agree. If only the two windows moved it would only confuse the user.

>             At the moment the patch is way too strict. The problems I 
>             see are: 
> 
>              - You can't lower transients below the parents anymore, 
>                even with DontLowerTransient and DontRaiseTransient set. 
> 
> Well that *is* what I am trying to achieve, but I didn't intend to make it
> obligatory.

Of course. I was just unable to turn that new feature off again.

> My overall aim is for a configuration in which transients cannot
> be obscured by their parent. This is Motif behaviour, and some of
> our applications actually rely upon it. It can be partly achieved
> with RaiseTransient and the new StackTransientParent, but still needs
> something more to prevent the movement of the parent above its transients;
> ie. when they are already raised, and the parent is raised again.

Okay.

> I would like another new style, say RaiseTransientStrict, which does
> everything RaiseTransient does except allowing the parent to toggle
> above/below the transients when they are all at the top of their layer.

That is exactly what Raise/LowerTransientStrict are doing now (without
any patches). I wrote this a while ago. I tend to remove this feature
again because it happens too often by accident. E.g. if you have a
Move-and-Raise function bound to the window title the window toggles
above or below its transients each time it's used. Very ugly.

> I'm afraid there's more that needs cleaning up too: in my original
> patch submission for 2.0.46 I included treatment of a whole tree of
> transients (where a main-window-with-transient-subwindows is itself
> a transient of another window). Well I did that out of a belief that
> nothing prohibits it. You quite reasonably asked "Does this ever happen",
> and it seems the answer is "Yup". Start Netscape, Edit->Preferences,
> Navigator->Applications, press the "Choose" button to select a destination
> for Downloaded files and bingo, you have three windows (1) File Browser
> which is transient for (2) "Netscape: Preferences", which is itself a
> transient for (3) the main Netscape window. It seems to me that  with
> RaiseTransient, a raise of (3) which raises (2) really ought to raise
> (1) too.

Take your time, we're not in a hurry.

> I'll send patches for StackTransientParent and RaiseTransientStrict
> shortly. What do you think about the tree of transients?

Nothing :) if it doesn't slow things down dramatically I have
no objections.

BTW, since you wrote the last patch I made a small but important
patch to stack.c. Please fetch a current development snapshot
and merge it with your patch.

Bye

Dominik ^_^

--
Dominik Vogt, [email-masked]
Reply-To: [email-masked]
--
Visit the official FVWM web page at <URL:http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked]